package sample.test;

import java.util.Date;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.support.DependencyInjectionTestExecutionListener;
import org.springframework.test.context.support.DirtiesContextTestExecutionListener;
import org.springframework.transaction.annotation.Transactional;

import sample.entity.Record;

import com.github.springtestdbunit.TransactionDbUnitTestExecutionListener;
import com.github.springtestdbunit.annotation.DbUnitConfiguration;

@RunWith(SpringJUnit4ClassRunner.class)
@TestExecutionListeners({ DependencyInjectionTestExecutionListener.class,
		DirtiesContextTestExecutionListener.class,
		TransactionDbUnitTestExecutionListener.class })
@ContextConfiguration(locations = { "/spring/applicationContext.xml" })
@DbUnitConfiguration(databaseConnection = "databaseConnection")
@Transactional
public class JpaIT {
	private static final Logger LOGGER = LoggerFactory.getLogger(JpaIT.class);

	@PersistenceContext
	private EntityManager em;

	@Test
	public void shouldCreateAndUpdateRecord() throws Exception {
		Record record = new Record();

		record.setFileContent(new byte[0]);
		LOGGER.info("persisting entity...");
		em.persist(record);

		// this triggers the issue
		LOGGER.info("detaching entity...");
		em.detach(record);

		record.setDate(new Date());
		LOGGER.info("merging entity...");
		em.merge(record);
	}
}